// --------------------------------------------------------------------
// Copyright (c) 2012 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/   
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
//Date:  Tue Feb 28 09:17:32 2012
//---------------------------------------------------------------------
//`define ENABLE_DDR3A
//`define ENABLE_DDR3B
`define ENABLE_PCIE
//`define ENABLE_QDRIIA
//`define ENABLE_QDRIIB
//`define ENABLE_QDRIIC
//`define ENABLE_QDRIID
//`define ENABLE_SATA_DEVICE
//`define ENABLE_SATA_HOST
`define ENABLE_SFPA
`define ENABLE_SFPB
`define ENABLE_SFPC
`define ENABLE_SFPD
//`define ENABLE_SFP1G_REFCLK


module DE5_Reference_Router(

							///////////BUTTON/////////////

							BUTTON,

							/////////CLOCK/////////
							CLOCK_SCL,
							CLOCK_SDA,

							/////////CPU/////////
							CPU_RESET_n,
`ifdef ENABLE_DDR3A
							/////////DDR3A/////////
							DDR3A_A,
							DDR3A_BA,
							DDR3A_CAS_n,
							DDR3A_CK,
							DDR3A_CKE,
							DDR3A_CK_n,
							DDR3A_CS_n,
							DDR3A_DM,
							DDR3A_DQ,
							DDR3A_DQS,
							DDR3A_DQS_n,
							DDR3A_EVENT_n,
							DDR3A_ODT,
							DDR3A_RAS_n,
							DDR3A_RESET_n,
							DDR3A_SCL,
							DDR3A_SDA,
							DDR3A_WE_n,
`endif 

`ifdef ENABLE_DDR3B
							/////////DDR3B/////////
							DDR3B_A,
							DDR3B_BA,
							DDR3B_CAS_n,
							DDR3B_CK,
							DDR3B_CKE,
							DDR3B_CK_n,
							DDR3B_CS_n,
							DDR3B_DM,
							DDR3B_DQ,
							DDR3B_DQS,
							DDR3B_DQS_n,
							DDR3B_EVENT_n,
							DDR3B_ODT,
							DDR3B_RAS_n,
							DDR3B_RESET_n,
							DDR3B_SCL,
							DDR3B_SDA,
							DDR3B_WE_n,

`endif  
							/////////FAN/////////
							FAN_CTRL,

							/////////FLASH/////////
							FLASH_ADV_n,
							FLASH_CE_n,
							FLASH_CLK,
							FLASH_OE_n,
							FLASH_RDY_BSY_n,
							FLASH_RESET_n,
							FLASH_WE_n,

							/////////FSM/////////
							FSM_A,
							FSM_D,

							/////////HEX0/////////
							HEX0_D,
							HEX0_DP,

							/////////HEX1/////////
							HEX1_D,
							HEX1_DP,

							/////////LED/////////
							LED,
							LED_BRACKET,
							LED_RJ45_L,
							LED_RJ45_R,


							/////////OSC/////////
							OSC_50_B3B,
							OSC_50_B3D,
							OSC_50_B4A,
							OSC_50_B4D,
							OSC_50_B7A,
							OSC_50_B7D,
							OSC_50_B8A,
							OSC_50_B8D,
`ifdef ENABLE_PCIE
							/////////PCIE/////////
							PCIE_PERST_n,
							PCIE_REFCLK_p,
							PCIE_RX_p,
							PCIE_SMBCLK,
							PCIE_SMBDAT,
							PCIE_TX_p,
							PCIE_WAKE_n,
`endif

							PLL_SCL,
							PLL_SDA,
							
`ifdef ENABLE_QDRIIA							
							/////////QDRIIA/////////
							QDRIIA_A,
							QDRIIA_BWS_n,
							QDRIIA_CQ_n,
							QDRIIA_CQ_p,
							QDRIIA_D,
							QDRIIA_DOFF_n,
							QDRIIA_K_n,
							QDRIIA_K_p,
							QDRIIA_ODT,
							QDRIIA_Q,
							QDRIIA_QVLD,
							QDRIIA_RPS_n,
							QDRIIA_WPS_n,
`endif
`ifdef ENABLE_QDRIIB
							/////////QDRIIB/////////
							QDRIIB_A,
							QDRIIB_BWS_n,
							QDRIIB_CQ_n,
							QDRIIB_CQ_p,
							QDRIIB_D,
							QDRIIB_DOFF_n,
							QDRIIB_K_n,
							QDRIIB_K_p,
							QDRIIB_ODT,
							QDRIIB_Q,
							QDRIIB_QVLD,
							QDRIIB_RPS_n,
							QDRIIB_WPS_n,
`endif
`ifdef ENABLE_QDRIIC
							/////////QDRIIC/////////
							QDRIIC_A,
							QDRIIC_BWS_n,
							QDRIIC_CQ_n,
							QDRIIC_CQ_p,
							QDRIIC_D,
							QDRIIC_DOFF_n,
							QDRIIC_K_n,
							QDRIIC_K_p,
							QDRIIC_ODT,
							QDRIIC_Q,
							QDRIIC_QVLD,
							QDRIIC_RPS_n,
							QDRIIC_WPS_n,
`endif
`ifdef ENABLE_QDRIID
							/////////QDRIID/////////
							QDRIID_A,
							QDRIID_BWS_n,
							QDRIID_CQ_n,
							QDRIID_CQ_p,
							QDRIID_D,
							QDRIID_DOFF_n,
							QDRIID_K_n,
							QDRIID_K_p,
							QDRIID_ODT,
							QDRIID_Q,
							QDRIID_QVLD,
							QDRIID_RPS_n,
							QDRIID_WPS_n,
`endif
							/////////RS422/////////
							RS422_DE,
							RS422_DIN,
							RS422_DOUT,
							RS422_RE_n,
							RS422_TE,

							/////////RZQ/////////
							RZQ_0,
							RZQ_1,
							RZQ_4,
							RZQ_5,
`ifdef ENABLE_SATA_DEVICE
							/////////SATA/////////
							SATA_DEVICE_RX_p,
							SATA_DEVICE_TX_p,
							SATA_DEVICE_REFCLK_p,
`endif
`ifdef ENABLE_SATA_HOST
							SATA_HOST_RX_p,
							SATA_HOST_TX_p,
							SATA_HOST_REFCLK_p,
`endif
							
							/////////SPF CLOCK/////////														
`ifdef ENABLE_SFPA
							SFP_REFCLK_p,
`elsif ENABLE_SFPB
							SFP_REFCLK_p,
`elsif ENABLE_SFPC
							SFP_REFCLK_p,
`elsif ENABLE_SFPD
							SFP_REFCLK_p,						
`endif 

`ifdef ENABLE_SFP1G_REFCLK
							SFP1G_REFCLK_p,
`endif
						

							

`ifdef ENABLE_SFPA					
							/////////SFPA/////////
							SFPA_LOS,
							SFPA_MOD0_PRSNT_n,
							SFPA_MOD1_SCL,
							SFPA_MOD2_SDA,
							SFPA_RATESEL,
							SFPA_RX_p,
							SFPA_TXDISABLE,
							SFPA_TXFAULT,
							SFPA_TX_p,
`endif
`ifdef ENABLE_SFPB
							/////////SFPB/////////
							SFPB_LOS,
							SFPB_MOD0_PRSNT_n,
							SFPB_MOD1_SCL,
							SFPB_MOD2_SDA,
							SFPB_RATESEL,
							SFPB_RX_p,
							SFPB_TXDISABLE,
							SFPB_TXFAULT,
							SFPB_TX_p,
`endif
`ifdef ENABLE_SFPC
							/////////SFPC/////////
							SFPC_LOS,
							SFPC_MOD0_PRSNT_n,
							SFPC_MOD1_SCL,
							SFPC_MOD2_SDA,
							SFPC_RATESEL,
							SFPC_RX_p,
							SFPC_TXDISABLE,
							SFPC_TXFAULT,
							SFPC_TX_p,
`endif
`ifdef ENABLE_SFPD
							/////////SFPD/////////
							SFPD_LOS,
							SFPD_MOD0_PRSNT_n,
							SFPD_MOD1_SCL,
							SFPD_MOD2_SDA,
							SFPD_RATESEL,
							SFPD_RX_p,
							SFPD_TXDISABLE,
							SFPD_TXFAULT,
							SFPD_TX_p,
`endif
							/////////SMA/////////
							SMA_CLKIN,
							SMA_CLKOUT,

							/////////SW/////////
							SW,

							/////////TEMP/////////
							TEMP_CLK,
							TEMP_DATA,
							TEMP_INT_n,
							TEMP_OVERT_n,
							
);

//=======================================================
//  PORT declarations
//=======================================================

							///////////BUTTON/////////////

input								[3:0]						BUTTON;

///////// CLOCK /////////
output														CLOCK_SCL;
inout															CLOCK_SDA;

///////// CPU /////////
input															CPU_RESET_n;
`ifdef ENABLE_DDR3A
///////// DDR3A /////////
output							[15:0]					DDR3A_A;
output							[2:0]						DDR3A_BA;
output														DDR3A_CAS_n;
output							[1:0]						DDR3A_CK;
output							[1:0]						DDR3A_CKE;
output							[1:0]						DDR3A_CK_n;
output							[1:0]						DDR3A_CS_n;
output							[7:0]						DDR3A_DM;
inout								[63:0]					DDR3A_DQ;
inout								[7:0]						DDR3A_DQS;
inout								[7:0]						DDR3A_DQS_n;
input															DDR3A_EVENT_n;
output							[1:0]						DDR3A_ODT;
output														DDR3A_RAS_n;
output														DDR3A_RESET_n;
output														DDR3A_SCL;
inout															DDR3A_SDA;
output														DDR3A_WE_n;
`endif
`ifdef ENABLE_DDR3B
///////// DDR3B /////////
output							[15:0]					DDR3B_A;
output							[2:0]						DDR3B_BA;
output														DDR3B_CAS_n;
output							[1:0]						DDR3B_CK;
output							[1:0]						DDR3B_CKE;
output							[1:0]						DDR3B_CK_n;
output							[1:0]						DDR3B_CS_n;
output							[7:0]						DDR3B_DM;
inout								[63:0]					DDR3B_DQ;
inout								[7:0]						DDR3B_DQS;
inout								[7:0]						DDR3B_DQS_n;
input															DDR3B_EVENT_n;
output							[1:0]						DDR3B_ODT;
output														DDR3B_RAS_n;
output														DDR3B_RESET_n;
output														DDR3B_SCL;
inout															DDR3B_SDA;
output														DDR3B_WE_n;
`endif
///////// FAN /////////
inout															FAN_CTRL;

///////// FLASH /////////
output														FLASH_ADV_n;
output							[1:0]						FLASH_CE_n;
output														FLASH_CLK;
output														FLASH_OE_n;
input								[1:0]						FLASH_RDY_BSY_n;
output														FLASH_RESET_n;
output														FLASH_WE_n;

///////// FSM /////////
output							[26:0]					FSM_A;
inout								[31:0]					FSM_D;

///////// HEX0 /////////
output							[6:0]						HEX0_D;
output														HEX0_DP;

///////// HEX1 /////////
output							[6:0]						HEX1_D;
output														HEX1_DP;

///////// LED /////////
output							[3:0]						LED;
output							[3:0]						LED_BRACKET;
output														LED_RJ45_L;
output														LED_RJ45_R;


///////// OSC ////////
input															OSC_50_B3B;
input															OSC_50_B3D;
input															OSC_50_B4A;
input															OSC_50_B4D;
input															OSC_50_B7A;
input															OSC_50_B7D;
input															OSC_50_B8A;
input															OSC_50_B8D;

`ifdef ENABLE_PCIE
///////// PCIE /////////
input															PCIE_PERST_n;
input															PCIE_REFCLK_p;
input								[7:0]						PCIE_RX_p;
input															PCIE_SMBCLK;
inout															PCIE_SMBDAT;
output							[7:0]						PCIE_TX_p;
output														PCIE_WAKE_n;
`endif

output														PLL_SCL;
inout															PLL_SDA;

`ifdef ENABLE_QDRIIA
///////// QDRIIA /////////
output							[20:0]					QDRIIA_A;
output							[1:0]						QDRIIA_BWS_n;
input															QDRIIA_CQ_n;
input															QDRIIA_CQ_p;
output							[17:0]					QDRIIA_D;
output														QDRIIA_DOFF_n;
output														QDRIIA_K_n;
output														QDRIIA_K_p;
output														QDRIIA_ODT;
input								[17:0]					QDRIIA_Q;
input															QDRIIA_QVLD;
output														QDRIIA_RPS_n;
output														QDRIIA_WPS_n;
`endif
`ifdef ENABLE_QDRIIB
///////// QDRIIB /////////
output							[20:0]					QDRIIB_A;
output							[1:0]						QDRIIB_BWS_n;
input															QDRIIB_CQ_n;
input															QDRIIB_CQ_p;
output							[17:0]					QDRIIB_D;
output														QDRIIB_DOFF_n;
output														QDRIIB_K_n;
output														QDRIIB_K_p;
output														QDRIIB_ODT;
input								[17:0]					QDRIIB_Q;
input															QDRIIB_QVLD;
output														QDRIIB_RPS_n;
output														QDRIIB_WPS_n;
`endif
`ifdef ENABLE_QDRIIC
///////// QDRIIC /////////
output							[20:0]					QDRIIC_A;
output							[1:0]						QDRIIC_BWS_n;
input															QDRIIC_CQ_n;
input															QDRIIC_CQ_p;
output							[17:0]					QDRIIC_D;
output														QDRIIC_DOFF_n;
output														QDRIIC_K_n;
output														QDRIIC_K_p;
output														QDRIIC_ODT;
input								[17:0]					QDRIIC_Q;
input															QDRIIC_QVLD;
output														QDRIIC_RPS_n;
output														QDRIIC_WPS_n;
`endif
`ifdef ENABLE_QDRIID
///////// QDRIID /////////
output							[20:0]					QDRIID_A;
output							[1:0]						QDRIID_BWS_n;
input															QDRIID_CQ_n;
input															QDRIID_CQ_p;
output							[17:0]					QDRIID_D;
output														QDRIID_DOFF_n;
output														QDRIID_K_n;
output														QDRIID_K_p;
output														QDRIID_ODT;
input								[17:0]					QDRIID_Q;
input															QDRIID_QVLD;
output														QDRIID_RPS_n;
output														QDRIID_WPS_n;
`endif 
///////// RS422 /////////
output														RS422_DE;
input															RS422_DIN;
output														RS422_DOUT;
output														RS422_RE_n;
output														RS422_TE;

///////// RZQ /////////
input															RZQ_0;
input															RZQ_1;
input															RZQ_4;
input															RZQ_5;

`ifdef ENABLE_SATA_DEVICE
///////// SATA /////////
input								[1:0]						SATA_DEVICE_RX_p;
output							[1:0]						SATA_DEVICE_TX_p;
input															SATA_DEVICE_REFCLK_p;
`endif
`ifdef ENABLE_SATA_HOST
input								[1:0]						SATA_HOST_RX_p;
output							[1:0]						SATA_HOST_TX_p;
input															SATA_HOST_REFCLK_p;
`endif 


/////////SPF CLOCK/////////
`ifdef ENABLE_SFPA
input															SFP_REFCLK_p;
`elsif ENABLE_SFPB 
input															SFP_REFCLK_p;
`elsif ENABLE_SFPC 
input															SFP_REFCLK_p;
`elsif ENABLE_SFPD 
input															SFP_REFCLK_p;
`endif

`ifdef ENABLE_SFP1G_REFCLK
input															SFP1G_REFCLK_p;
`endif



`ifdef ENABLE_SFPA
///////// SFPA /////////
input															SFPA_LOS;
input															SFPA_MOD0_PRSNT_n;
output														SFPA_MOD1_SCL;
inout															SFPA_MOD2_SDA;
output							[1:0]						SFPA_RATESEL;
input															SFPA_RX_p;
output														SFPA_TXDISABLE;
input															SFPA_TXFAULT;
output														SFPA_TX_p;
`endif
`ifdef ENABLE_SFPB
///////// SFPB /////////
input															SFPB_LOS;
input															SFPB_MOD0_PRSNT_n;
output														SFPB_MOD1_SCL;
inout															SFPB_MOD2_SDA;
output							[1:0]						SFPB_RATESEL;
input															SFPB_RX_p;
output														SFPB_TXDISABLE;
input															SFPB_TXFAULT;
output														SFPB_TX_p;
`endif
`ifdef ENABLE_SFPC
///////// SFPC /////////
input															SFPC_LOS;
input															SFPC_MOD0_PRSNT_n;
output														SFPC_MOD1_SCL;
inout															SFPC_MOD2_SDA;
output							[1:0]						SFPC_RATESEL;
input															SFPC_RX_p;
output														SFPC_TXDISABLE;
input															SFPC_TXFAULT;
output														SFPC_TX_p;
`endif
`ifdef ENABLE_SFPD
///////// SFPD /////////
input															SFPD_LOS;
input															SFPD_MOD0_PRSNT_n;
output														SFPD_MOD1_SCL;
inout															SFPD_MOD2_SDA;
output							[1:0]						SFPD_RATESEL;
input															SFPD_RX_p;
output														SFPD_TXDISABLE;
input															SFPD_TXFAULT;
output														SFPD_TX_p;
`endif
///////// SMA /////////
input															SMA_CLKIN;
output														SMA_CLKOUT;

///////// SW /////////
input								[3:0]						SW;

///////// TEMP /////////
output														TEMP_CLK;
inout															TEMP_DATA;
input															TEMP_INT_n;
input															TEMP_OVERT_n;


//=======================================================
//  REG/WIRE declarations
//=======================================================

wire user_reset_n;
wire [2:0]	clk_type;
wire clock_freq_result;
wire si570_controller_start;
wire si570_config_ready;
wire reset_n;
wire clk_125;

wire xgmii_rx_clk_clk;

//---------avalon bus signals to 10g example--------------
wire 		[63:0] tx_sc_fifo_in_data;           //  eth_10g_design_example_0_tx_sc_fifo_in.data
wire		tx_sc_fifo_in_valid;          //                                        .valid
wire		tx_sc_fifo_in_ready;          //                                        .ready
wire		tx_sc_fifo_in_startofpacket;  //                                        .startofpacket
wire		tx_sc_fifo_in_endofpacket;    //                                        .endofpacket
wire		tx_sc_fifo_in_empty;          //                                        .empty
wire		tx_sc_fifo_in_error;          //                                        .error
wire		[63:0] rx_sc_fifo_out_data;          // eth_10g_design_example_0_rx_sc_fifo_out.data
wire		rx_sc_fifo_out_valid;         //                                        .valid
wire		rx_sc_fifo_out_ready;         //                                        .ready
wire		rx_sc_fifo_out_startofpacket; //                                        .startofpacket
wire		rx_sc_fifo_out_endofpacket;   //                                        .endofpacket
wire		rx_sc_fifo_out_empty;         //                                        .empty
wire		rx_sc_fifo_out_error;

wire 		gmac_rx_goodframe;
reg 		gmac_rx_goodframe_reg;
wire     gmac_rx_badframe; 
reg		gmac_rx_badframe_reg;
//=======================================================
//  Structural coding
//=======================================================

assign user_reset_n = BUTTON[0];

//////////////////////////////////////////
// turn on the fan
assign FAN_CTRL = 1'b1;


////////////////////////////////////////
// configure external pll Si570 which provides xcvr ref clock

//assign clk_type = 3'b000;  //100.0 MHZ
//assign clk_type = 3'b001;  //125.0 MHZ
//assign clk_type = 3'b010;  //156.25.0 MHZ
//assign clk_type = 3'b011;  //250 MHZ
//assign clk_type = 3'b100;  //312.5 MHZ
//assign clk_type = 3'b101;  //322.26 MHZ
assign clk_type = 3'b110;  //644.53125 MHZ


si570_controller u1(

.iCLK(OSC_50_B3B), // system   clock 50mhz 
.iRST_n(user_reset_n), // system reset
.iStart(si570_controller_start), //giving 1 50Mhz cycle high pulse to set frequency
.iFREQ_MODE(clk_type),//clock frequency mode   000:100Mhz, 001: 125Mhz, 010:156.25Mhz, 011:250Mhz, 100:312.5Mhz , 101:322.26Mhz , 110:644.53Mhz ,111:100Mhz 
.I2C_CLK(CLOCK_SCL),
.I2C_DATA(CLOCK_SDA),
.oController_Ready(),
);


edge_detector edge_detector(

.iCLK(OSC_50_B3B),
.iRST_n(user_reset_n),
.iIn(BUTTON[1]),
.oDEBOUNCE_OUT(si570_controller_start),
);


////////////////////////////////////////
// generate clk125 for phy_mgmt

mgmt_pll mgmt_pll_inst(
		.refclk(OSC_50_B3B),   //  refclk.clk
		.rst(1'b0),      //   reset.reset
		.outclk_0(clk_125), // outclk0.clk
		.locked(reset_n)    //  locked.export
	);
	
	wire [71:0]   phy_0_xgmii_tx_data;
	wire [71:0]   phy_0_xgmii_rx_data;
	wire [71:0]   phy_1_xgmii_tx_data;
	wire [71:0]   phy_1_xgmii_rx_data;
	wire [71:0]   phy_2_xgmii_tx_data;
	wire [71:0]   phy_2_xgmii_rx_data;
	wire [71:0]   phy_3_xgmii_tx_data;
	wire [71:0]   phy_3_xgmii_rx_data;

phy_10gbaser phy_10gbaser_inst(
		.pll_ref_clk                     (SFP_REFCLK_p),          //        pll_ref_clk.clk
		.xgmii_rx_clk                    (xgmii_rx_clk_clk),         //       xgmii_rx_clk.clk
		.tx_ready                        (),             //           tx_ready.export
		.xgmii_tx_clk                    (xgmii_rx_clk_clk),         //       xgmii_tx_clk.clk
		.rx_ready                        (),             //           rx_ready.export
		.rx_data_ready                   (),        //      rx_data_ready.export
		.xgmii_rx_dc_0                   (phy_0_xgmii_rx_data),        //      xgmii_rx_dc_0.data
		.xgmii_tx_dc_0                   (phy_0_xgmii_tx_data),        //      xgmii_tx_dc_0.data
		.xgmii_rx_dc_1                   (phy_1_xgmii_rx_data),        //      xgmii_rx_dc_0.data
		.xgmii_tx_dc_1                   (phy_1_xgmii_tx_data),        //      xgmii_tx_dc_0.data
		.xgmii_rx_dc_2                   (phy_2_xgmii_rx_data),        //      xgmii_rx_dc_0.data
		.xgmii_tx_dc_2                   (phy_2_xgmii_tx_data),        //      xgmii_tx_dc_0.data
		.xgmii_rx_dc_3                   (phy_3_xgmii_rx_data),        //      xgmii_rx_dc_0.data
		.xgmii_tx_dc_3                   (phy_3_xgmii_tx_data),        //      xgmii_tx_dc_0.data
		.rx_serial_data_0                (SFPA_RX_p),     //   rx_serial_data_0.export
		.tx_serial_data_0                (SFPA_TX_p),     //   tx_serial_data_0.export
		.rx_serial_data_1                (SFPB_RX_p),   
		.tx_serial_data_1                (SFPB_TX_p),    
		.rx_serial_data_2                (SFPC_RX_p),     //   rx_serial_data_0.export
		.tx_serial_data_2                (SFPC_TX_p),     //   tx_serial_data_0.export
		.rx_serial_data_3                (SFPD_RX_p),   
		.tx_serial_data_3                (SFPD_TX_p),    
		.reconfig_from_xcvr              (),   // reconfig_from_xcvr.reconfig_from_xcvr
		.reconfig_to_xcvr                (),     //   reconfig_to_xcvr.reconfig_to_xcvr
		.phy_mgmt_clk                    (OSC_50_B3B),         //       phy_mgmt_clk.clk
		.phy_mgmt_clk_reset              (~reset_n),   // phy_mgmt_clk_reset.reset
		.phy_mgmt_address                (),     //           phy_mgmt.address
		.phy_mgmt_read                   (),        //                   .read
		.phy_mgmt_readdata               (),    //                   .readdata
		.phy_mgmt_write                  (),       //                   .write
		.phy_mgmt_writedata              (),   //                   .writedata
		.phy_mgmt_waitrequest            ()  //                   .waitrequest
	);
	
DE5_Reference_Router_Qsys DE5_Reference_Router_Qsys_inst(
		//.ref_clk_644mhz_clk(SFP_REFCLK_p),                                                    //                                         ref_clk.clk
		.eth_10g_mac_0_xgmii_tx_data(phy_0_xgmii_tx_data),                                          //                                  tx_serial_data.export
		.eth_10g_mac_0_xgmii_rx_data(phy_0_xgmii_rx_data),                                          //                                  rx_serial_data.export
		.eth_10g_mac_1_xgmii_tx_data(phy_1_xgmii_tx_data),                                          //                                  tx_serial_data.export
		.eth_10g_mac_1_xgmii_rx_data(phy_1_xgmii_rx_data),                                          //                                  rx_serial_data.export
		.eth_10g_mac_2_xgmii_tx_data(phy_2_xgmii_tx_data),                                          //                                  tx_serial_data.export
		.eth_10g_mac_2_xgmii_rx_data(phy_2_xgmii_rx_data),                                          //                                  rx_serial_data.export
		.eth_10g_mac_3_xgmii_tx_data(phy_3_xgmii_tx_data),                                          //                                  tx_serial_data.export
		.eth_10g_mac_3_xgmii_rx_data(phy_3_xgmii_rx_data),                                          //                                  rx_serial_data.export
		.in_clk_125_clk(clk_125),                                                 //                                      in_clk_125.clk
		.in_reset_reset_n(reset_n),                                               //                                        in_reset.reset_n
		.jtag_master_0_master_reset_reset(),                               //                      jtag_master_0_master_reset.reset
		.ethernet_port_interface_0_conduit_end_export(SW[0]),                    //           ethernet_port_interface_0_conduit_end.export
		.phy_clk156_clk(xgmii_rx_clk_clk),
		.pcie_sv_hip_avmm_0_refclk_clk(PCIE_REFCLK_p),                                            //                                refclk.clk
		.pcie_sv_hip_avmm_0_npor_npor(1'b1),                                             //                                  npor.npor
		.pcie_sv_hip_avmm_0_npor_pin_perst(PCIE_PERST_n),                                        //                                      .pin_perst
		.hip_serial_rx_in0(PCIE_RX_p[0]),         //        hip_serial.rx_in0
		.hip_serial_rx_in1(PCIE_RX_p[1]),         //                  .rx_in1
		.hip_serial_rx_in2(PCIE_RX_p[2]),         //                  .rx_in2
		.hip_serial_rx_in3(PCIE_RX_p[3]),         //                  .rx_in3
		.hip_serial_rx_in4(PCIE_RX_p[4]),         //        hip_serial.rx_in0
		.hip_serial_rx_in5(PCIE_RX_p[5]),         //                  .rx_in1
		.hip_serial_rx_in6(PCIE_RX_p[6]),         //                  .rx_in2
		.hip_serial_rx_in7(PCIE_RX_p[7]),         //                  .rx_in3
		.hip_serial_tx_out0(PCIE_TX_p[0]),        //                  .tx_out0
		.hip_serial_tx_out1(PCIE_TX_p[1]),        //                  .tx_out1
		.hip_serial_tx_out2(PCIE_TX_p[2]),        //                  .tx_out2
		.hip_serial_tx_out3(PCIE_TX_p[3]),        //                  .tx_out3
		.hip_serial_tx_out4(PCIE_TX_p[4]),        //                  .tx_out0
		.hip_serial_tx_out5(PCIE_TX_p[5]),        //                  .tx_out1
		.hip_serial_tx_out6(PCIE_TX_p[6]),        //                  .tx_out2
		.hip_serial_tx_out7(PCIE_TX_p[7])        //                  .tx_out3
	);
	
	
////////////////////////////////////////
//altera_10g_example altera_10g_example_inst(
//		.in_clk_125_clk(clk_125),                                             //                                   clk_0.clk
//		.xgmii_tx_clk_clk(xgmii_rx_clk_clk),
//		.xgmii_rx_clk_clk(xgmii_rx_clk_clk),
//		.in_reset_reset_n(reset_n),                                       //                                 reset_0.reset_n
//		.tx_reset_reset_n(reset_n),
//		.rx_reset_reset_n(reset_n),
//		.ref_clk_clk(SFP_REFCLK_p),                                             //                                   clk_2.clk
//		.tx_serial_data_export(SFPB_TX_p),        // eth_10g_design_example_0_tx_serial_data.export
//		.rx_serial_data_export(SFPB_RX_p),        // eth_10g_design_example_0_rx_serial_data.export
//		.tx_sc_fifo_in_data(tx_sc_fifo_in_data),           //  eth_10g_design_example_0_tx_sc_fifo_in.data
//		.tx_sc_fifo_in_valid(tx_sc_fifo_in_valid),          //                                        .valid
//		.tx_sc_fifo_in_ready(tx_sc_fifo_in_ready),          //                                        .ready
//		.tx_sc_fifo_in_startofpacket(tx_sc_fifo_in_startofpacket),  //                                        .startofpacket
//		.tx_sc_fifo_in_endofpacket(tx_sc_fifo_in_endofpacket),    //                                        .endofpacket
//		.tx_sc_fifo_in_empty(tx_sc_fifo_in_empty),          //                                        .empty
//		.tx_sc_fifo_in_error(1'b0),          //                                        .error
//		.rx_sc_fifo_out_data(rx_sc_fifo_out_data),          // eth_10g_design_example_0_rx_sc_fifo_out.data
//		.rx_sc_fifo_out_valid(rx_sc_fifo_out_valid),         //                                        .valid
//		.rx_sc_fifo_out_ready(1'b1),         //                                        .ready
//		.rx_sc_fifo_out_startofpacket(rx_sc_fifo_out_startofpacket), //                                        .startofpacket
//		.rx_sc_fifo_out_endofpacket(rx_sc_fifo_out_endofpacket),   //                                        .endofpacket
//		.rx_sc_fifo_out_empty(rx_sc_fifo_out_empty),         //                                        .empty
//		.rx_sc_fifo_out_error(rx_sc_fifo_out_error)          //                                        .error
//	);
//	
//	
//	wire  [63:0]            op_lut_in_data;
//   wire  [7:0]             op_lut_in_ctrl;
//   wire                    op_lut_in_wr;
//   wire                    op_lut_in_rdy;
//	
//	wire  [63:0]            oq_in_data;
//   wire  [7:0]             oq_in_ctrl;
//   wire                    oq_in_wr;
//   wire                    oq_in_rdy;
//	
//	
////---tx queue-----------------
//tx_queue
//	  #(.DATA_WIDTH(64),
//       .CTRL_WIDTH(8),
//       .ENABLE_HEADER(1),
//       .STAGE_NUMBER('hff)
//       ) tx_queue_0
//     (// data path interface
//      .in_ctrl                          (oq_in_ctrl),
//      .in_wr                            (oq_in_wr),
//      .in_data                          (oq_in_data),
//      .in_rdy                           (oq_in_rdy),
//      // gmac interface
//      .gmac_tx_data                     (tx_sc_fifo_in_data),
//      .gmac_tx_dvld                     (tx_sc_fifo_in_valid),
//      .gmac_tx_ack                      (tx_sc_fifo_in_ready),
//		.end_of_packet							 (tx_sc_fifo_in_endofpacket),
//		.start_of_packet    					 (tx_sc_fifo_in_startofpacket),
//      // reg signals
//      .tx_queue_en                      (1'b1),
////      .tx_pkt_sent                      (tx_pkt_sent),
////      .tx_pkt_stored                    (tx_pkt_stored),
////      .tx_pkt_byte_cnt                  (tx_pkt_byte_cnt),
////      .tx_pkt_word_cnt                  (tx_pkt_word_cnt),
//      // misc
//      .reset                            (~reset_n),
//      .clk                              (xgmii_rx_clk_clk),
//      .txcoreclk                        (xgmii_rx_clk_clk));
//		
//   rx_queue 
//     #(.DATA_WIDTH(64),
//       .CTRL_WIDTH(8),
//       .ENABLE_HEADER(1),
//       .STAGE_NUMBER('hff),
//       .PORT_NUMBER(0)
//       ) rx_queue
//     (// data path interface
//      .out_ctrl                         (op_lut_in_ctrl),
//      .out_wr                           (op_lut_in_wr),
//      .out_data                         (op_lut_in_data),
//      .out_rdy                          (op_lut_in_rdy),
//      // gmac interface
//      .gmac_rx_data                     (rx_sc_fifo_out_data),
//      .gmac_rx_dvld                     (rx_sc_fifo_out_valid),
//      .gmac_rx_goodframe                (gmac_rx_goodframe),
//      .gmac_rx_badframe                 (gmac_rx_badframe),
//      // reg signals
////      .rx_pkt_good                      (rx_pkt_good),
////      .rx_pkt_bad                       (rx_pkt_bad),
////      .rx_pkt_dropped                   (rx_pkt_dropped),
////      .rx_pkt_byte_cnt                  (rx_pkt_byte_cnt),
////      .rx_pkt_word_cnt                  (rx_pkt_word_cnt),
////      .rx_pkt_pulled                    (rx_pkt_pulled),
//      .rx_queue_en                      (1'b1),
//      // misc
//      .reset                            (~reset_n),
//      .clk                              (xgmii_rx_clk_clk),
//      .rxcoreclk                        (xgmii_rx_clk_clk));
//
//   output_port_lookup
//     #(.DATA_WIDTH(64),
//       .CTRL_WIDTH(8),
//       .UDP_REG_SRC_WIDTH (2),
//       .INPUT_ARBITER_STAGE_NUM(2),
//       .STAGE_NUM(4),
//       .NUM_OUTPUT_QUEUES(8),
//       .NUM_IQ_BITS(3))
//   output_port_lookup
//     (
//     
//     .out_data            (oq_in_data),
//     .out_ctrl             (oq_in_ctrl),
//     .out_wr               (oq_in_wr),
//     .out_rdy              (oq_in_rdy),   
//                           
//      // --- Interface to the rx input queues
//     .in_data              (op_lut_in_data),
//     .in_ctrl              (op_lut_in_ctrl),
//     .in_wr                (op_lut_in_wr),
//     .in_rdy               (op_lut_in_rdy),
//                           
//      // --- Register interface
////     .reg_req_in           (op_lut_in_reg_req),
////     .reg_ack_in           (op_lut_in_reg_ack),
////     .reg_rd_wr_L_in       (op_lut_in_reg_rd_wr_L),
////     .reg_addr_in          (op_lut_in_reg_addr),
////     .reg_data_in          (op_lut_in_reg_data),
////     .reg_src_in           (op_lut_in_reg_src),
////
////     .reg_req_out          (pkt_cap_reg_req),
////     .reg_ack_out          (pkt_cap_reg_ack),
////     .reg_rd_wr_L_out      (pkt_cap_reg_rd_wr_L),
////     .reg_addr_out         (pkt_cap_reg_addr),
////     .reg_data_out         (pkt_cap_reg_data),
////     .reg_src_out          (pkt_cap_reg_src),
//
//      // --- Misc
//		.ready_out         (ready_out),
//     .clk                  (clk),
//     .reset                (reset));		
//		
		
// packet_composer #(
//		.WORKER_ADDR_WIDTH(2),
//		.TOTAL_DATA(8)
//	) composer_0 (
//		
//   	// --- interface to next module
//   	.out_wr		(in_wr_0),
//   	.out_data	(in_data_0),
//   	.out_ctrl	(in_ctrl_0),     // new checksum assuming decremented TTL
//   	.out_rdy		(in_rdy_0),
//		
////		.sop(tx_sc_fifo_in_startofpacket),
////		.eop(tx_sc_fifo_in_endofpacket),
////		.vld(tx_sc_fifo_in_valid),
//		
//		.reset		(~reset_n),//pkt composer although instantiated here must be reset along with compute system
//   	.clk		(xgmii_rx_clk_clk)
//   );
		
		
///////////////////////////////////////////
// generate heart beat for clock
wire xcvr_refclk_hb;
heart_beat heart_beat_xcvr_refclk(
	.clk(SFP_REFCLK_p),
	.led(xcvr_refclk_hb)
);

wire clk125_hb;
heart_beat heart_beat_clk_125(
	.clk(xgmii_rx_clk_clk),
	.led(clk125_hb)
);


//////////////////////////////////////////
// led indication
//assign LED[0] = phy_mgmt_clk_reset?1'b0:1'b1; // on if reset assert
assign LED[2] = clk125_hb; // heart beat of clk125
assign LED[3] = xcvr_refclk_hb; // heart beat of xcvr refclk

always@(*) begin
		if ( rx_sc_fifo_out_error == 0 ) begin
			gmac_rx_goodframe_reg = 1'b1;
			gmac_rx_badframe_reg = 1'b0;
		end
		else begin
			gmac_rx_goodframe_reg = 1'b0;
			gmac_rx_badframe_reg = 1'b1;
		end
	end	
	
	assign gmac_rx_goodframe = gmac_rx_goodframe_reg;
	assign gmac_rx_badframe = gmac_rx_badframe_reg;
/////////////////////////////////////////////

	
endmodule 