#ifndef _DE5_ROUTER_PCIE_LIB_H_
#define _DE5_ROUTER_PCIE_LIB_H_

/************************************************************************
*  File: de5_router_pcie_lib.h
*
*  Library for accessing DE5_ROUTER_PCIE devices.
*  The code accesses hardware using WinDriver's WDC library.
*  Code was generated by DriverWizard v11.5.0.
*
*  Jungo Connectivity Confidential. Copyright (c) 2011 Jungo Connectivity Ltd.  http://www.jungo.com
*************************************************************************/

#include "wdc_lib.h"
#include "pci_regs.h"
#include "bits.h"

#ifdef __cplusplus
extern "C" {
#endif

/*************************************************************
  General definitions
 *************************************************************/
/* Default vendor and device IDs */
#define DE5_ROUTER_PCIE_DEFAULT_VENDOR_ID 0x1172 /* Vendor ID */
#define DE5_ROUTER_PCIE_DEFAULT_DEVICE_ID 0xE001 /* Device ID */


/* Address space information struct */
#define MAX_TYPE 8
typedef struct {
    DWORD dwAddrSpace;
    CHAR sType[MAX_TYPE];
    CHAR sName[MAX_NAME];
    CHAR sDesc[MAX_DESC];
} DE5_ROUTER_PCIE_ADDR_SPACE_INFO;

/* Interrupt result information struct */
typedef struct
{
    DWORD dwCounter; /* Number of interrupts received */
    DWORD dwLost;    /* Number of interrupts not yet handled */
    WD_INTERRUPT_WAIT_RESULT waitResult; /* See WD_INTERRUPT_WAIT_RESULT values in windrvr.h */
    DWORD dwEnabledIntType; /* Interrupt type that was actually enabled
                               (MSI/MSI-X/Level Sensitive/Edge-Triggered) */
    DWORD dwLastMessage; /* Message data of the last received MSI/MSI-X
                            (Windows Vista and higher); N/A to line-based
                            interrupts) */
} DE5_ROUTER_PCIE_INT_RESULT;
/* TODO: You can add fields to DE5_ROUTER_PCIE_INT_RESULT to store any additional
         information that you wish to pass to your diagnostics interrupt
         handler routine (DiagIntHandler() in de5_router_pcie_diag.c) */

/* DE5_ROUTER_PCIE diagnostics interrupt handler function type */
typedef void (*DE5_ROUTER_PCIE_INT_HANDLER)(WDC_DEVICE_HANDLE hDev,
    DE5_ROUTER_PCIE_INT_RESULT *pIntResult);

/* DE5_ROUTER_PCIE diagnostics plug-and-play and power management events handler function type */
typedef void (*DE5_ROUTER_PCIE_EVENT_HANDLER)(WDC_DEVICE_HANDLE hDev,
    DWORD dwAction);

/*************************************************************
  Function prototypes
 *************************************************************/
DWORD DE5_ROUTER_PCIE_LibInit(void);
DWORD DE5_ROUTER_PCIE_LibUninit(void);

WDC_DEVICE_HANDLE DE5_ROUTER_PCIE_DeviceOpen(const WD_PCI_CARD_INFO *pDeviceInfo);
BOOL DE5_ROUTER_PCIE_DeviceClose(WDC_DEVICE_HANDLE hDev);

DWORD DE5_ROUTER_PCIE_IntEnable(WDC_DEVICE_HANDLE hDev, DE5_ROUTER_PCIE_INT_HANDLER funcIntHandler);
DWORD DE5_ROUTER_PCIE_IntDisable(WDC_DEVICE_HANDLE hDev);
BOOL DE5_ROUTER_PCIE_IntIsEnabled(WDC_DEVICE_HANDLE hDev);

DWORD DE5_ROUTER_PCIE_EventRegister(WDC_DEVICE_HANDLE hDev, DE5_ROUTER_PCIE_EVENT_HANDLER funcEventHandler);
DWORD DE5_ROUTER_PCIE_EventUnregister(WDC_DEVICE_HANDLE hDev);
BOOL DE5_ROUTER_PCIE_EventIsRegistered(WDC_DEVICE_HANDLE hDev);

DWORD DE5_ROUTER_PCIE_GetNumAddrSpaces(WDC_DEVICE_HANDLE hDev);
BOOL DE5_ROUTER_PCIE_GetAddrSpaceInfo(WDC_DEVICE_HANDLE hDev, DE5_ROUTER_PCIE_ADDR_SPACE_INFO *pAddrSpaceInfo);


const char *DE5_ROUTER_PCIE_GetLastErr(void);

#ifdef __cplusplus
}
#endif

#endif
